import math
import map
import arrays
import pdb
import display
import pygame
r2d = 180/math.pi
dx = map.dx
dy = map.dy
dxh = map.dxh
GRASS = (0,128,0,255)
ROAD = (177,122,5,255)
#fd = open("debug.txt","w")
last_rng = 1000000
directions = [0,1,5,2,4,3]
visual = False
iterations = 0
def neighbor(hex,theta):
    (x,y) = map.hex_to_pix(hex)
    if theta == 0:
        x = x + dx
    elif theta == 1:
        x = x + dxh
        y = y + dy
    elif theta == 2:
        x = x - dxh
        y = y + dy
    elif theta == 3:
        x = x - dx
    elif theta == 4:
        x = x - dxh
        y = y - dy
    elif theta == 5:
        x = x + dxh
        y = y - dy
    return map.pix_to_hex((x,y))
def initial_heading(h1,h2):
    rc1 = map.hex_to_pix(h1)
    rc2 = map.hex_to_pix(h2)
    dx = rc2[0]-rc1[0]
    dy = rc2[1]-rc1[1]
    theta = int(math.atan2(dy,dx)*r2d+365)%360
    return int(theta/60)
def distance(hex,goal):
    (x1,y1) = hex
    (x2,y2) = goal
    dx = x2-x1
    dy = y2-y1
    return math.sqrt(dx*dx+dy*dy)
def traverse(hex,start):
    global terr,steps,goal,last_rng,iterations
    iterations += 1
#    pygame.time.wait(1000)
    if visual :
        display.Clear()
        display.Update()
    for r in range(map.nrows):
        for c in range(map.ncols):
            rng = terr[r][c]
            if rng < 1000 :
                (x,y) = map.hex_to_pix((r,c))
                if visual :
                    rect = pygame.Rect(x-rng/2,y-rng/2,rng,rng)
                    pygame.draw.rect(display.screen,(0,0,0),rect,0)
    (x,y) = map.hex_to_pix(hex)
    if visual :
        rect = pygame.Rect(x-5,y-5,10,10)
        pygame.draw.rect(display.screen,(0,255,0),rect,0)
        display.Flip()
#    pdb.set_trace()
#    pygame.time.wait(100)
#    pdb.set_trace()
    start_heading = initial_heading(hex,start)
#    print "start heading = ",start_heading
    for direction in range(6):
        hdg = (directions[direction]+start_heading)%6
        rng = terr[hex[0]][hex[1]]     
        valid = True
        nbr = neighbor(hex,hdg)
        ttype = map.terrain_type(nbr)
#        print 'nbr = ',nbr,'hdg = ',hdg,'rng = ',rng,'ttype = ',ttype
#        rec = str(hex)+'->'+str(nbr)+' hdg = '+str(hdg)
#        fd.write(rec+'\n')
        if ttype == GRASS:
            rng = rng + 2
        elif ttype == ROAD:
            rng = rng + 1
        else :
#            fd.write('invalid terrain type = '+str(ttype)+'\n')
            valid = False
        last_rng = terr[start[0]][start[1]]
        if rng >= last_rng:
            valid = False
        if valid :
            r = nbr[0]
            c = nbr[1]
            if terr[r][c] > rng :
                terr[r][c] = rng
#                for i in range(map.nrows):
#                    print terr[i]
                status = traverse(nbr,start)
    return True
def eval_terrain(hex,goalin):
    global terr,goal
    t1 = pygame.time.get_ticks()
    goal = goalin
    terr = arrays.create(map.nrows,map.ncols,1000)
    target = hex
    status = False
    rng = 0
    terr[goal[0]][goal[1]] = rng
    status = traverse(goal,hex)
#    for i in range(map.nrows):
#        rec = ''
#        for j in range(map.ncols):
#            rng = terr[i][j]
#            fld = str(rng)
#            rec += fld
#        fd.write(rec+'\n')
#    rng = terr[hex[0]][hex[1]]
#    for hdg in range(6):
#        nbr = neighbor(hex,hdg)
#        print "NBR 123",nbr
#        if terr[nbr[0]][nbr[1]] < rng :
#            target = nbr
    t2 = pygame.time.get_ticks()
    print "Time = ",t2-t1
    return terr
def next (hex,terr):
#    print "Next:"
#    print "Hex = ",hex
    rng = terr[hex[0]][hex[1]]
    target = hex
    for hdg in range(6):
        nbr = neighbor(hex,hdg)
#        print 'hdg = ',hdg,'nbr = ',nbr
        if map.onmap(nbr):
            if terr[nbr[0]][nbr[1]] < rng :
                target = nbr
                rng = terr[nbr[0]][nbr[1]]
    return target    
